
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Raft算法赏析 / iVAN</title>

    <meta name="description" content="Raft算法赏析 1 leader选举 1.1 刚开始所有server启动都是follower状态 然后等待leader或者candidate的RPC请求.或者超时. 上述3种情况处理如下: leader的AppendEntries RPC请求:更新term和leader信息,当前follower再重新重置到follower状态 candidate的RequestVote RPC请求:为candidate进行投票,如果candidate的term比自己的大,则当前follower再重新重置到follower状态">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Raft算法赏析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>1 leader选举</h1>
<ul>
<li>1.1 刚开始所有server启动都是follower状态</p>
<p>然后等待leader或者candidate的RPC请求、或者超时。</p>
<p>上述3种情况处理如下：</p>
<p>leader的AppendEntries RPC请求：更新term和leader信息，当前follower再重新重置到follower状态</p>
<p>candidate的RequestVote RPC请求：为candidate进行投票，如果candidate的term比自己的大，则当前follower再重新重置到follower状态</p>
<p>超时：转变为candidate，开始发起选举投票</li>
<li>1.2 candidate收集投票的过程
<p>candidate会为此次状态设置随机超时时间，一旦出现在当前term中大家都没有获取过半投票即split votes，超时时间短的更容易获得过半投票。</p>
<p>candidate会向所有的server发送RequestVote RPC请求，请求参数见下面的官方图</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3N0YXRpYy5vc2NoaW5hLm5ldC91cGxvYWRzL2ltZy8yMDE2MTAvMjExMTI3MjNfOXVTVS5wbmc=.jpg"></p>
<p>上面对参数都说明的很清楚了，我们来重点说说图中所说的这段话</p>
<pre><code>If votedFor is null or candidateId, and candidate’s log is at
least as up-to-date as receiver’s log, grant vote
</code></pre>
<p>votedFor是server保存的投票对象，一个server在一个term内只能投一次票。如果此时已经投过票了，即votedFor就不为空，那么此时就可以直接拒绝当前的投票（当然还要检查votedFor是不是就是请求的candidate）。</p>
<p>如果没有投过票：则对比candidate的log和当前server的log哪个更新，比较方式为谁的lastLog的term越大谁越新，如果term相同，谁的lastLog的index越大谁越新。</p>
<p>candidate统计投票信息，如果过半同意了则认为自己当选了leader，转变成leader状态，如果没有过半，则等待是否有新的leader产生，如果有的话，则转变成follower状态，如果没有然后超时的话，则开启下一次的选举。</li>
</ul>
<h1>2 log复制</h1>
<h2>2.1 请求都交给leader</h2>
<p>一旦leader选举成功，所有的client请求最终都会交给leader（如果client连接的是follower则follower转发给leader）</p>
<h2>2.2 处理请求过程</h2>
<ul>
<li>2.2.1 client请求到达leader</p>
<p>leader首先将该请求转化成entry，然后添加到自己的log中，得到该entry的index信息。entry中就包含了当前leader的term信息和在log中的index信息</li>
<li>2.2.2 leader复制上述entry到所有follower
<p>来看下官方给出的AppendEntries RPC请求</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3N0YXRpYy5vc2NoaW5hLm5ldC91cGxvYWRzL2ltZy8yMDE2MTAvMjExNTM1MjJfRmRqUC5wbmc=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3N0YXRpYy5vc2NoaW5hLm5ldC91cGxvYWRzL2ltZy8yMDE2MTAvMjExNTQwMjlfWDFHNS5wbmc=.jpg"></p>
<p>从上图可以看出对于每个follower，leader保持2个属性，一个就是nextIndex即leader要发给该follower的下一个entry的index，另一个就是matchIndex即follower发给leader的确认index。</p>
<p>一个leader在刚开始的时候会初始化：</p>
<pre><code>nextIndex=leader的log的最大index+1
matchIndex=0
</code></pre>
<p>然后开始准备AppendEntries RPC请求的参数</p>
<pre><code>prevLogIndex=nextIndex-1
prevLogTerm=从log中得到上述prevLogIndex对应的term
</code></pre>
<p>然后开始准备entries数组信息</p>
<pre><code>从leader的log的prevLogIndex+1开始到lastLog，此时是空的
</code></pre>
<p>然后把leader的commitIndex作为参数传给</p>
<pre><code>leaderCommit=commitIndex
</code></pre>
<p>至此，所有参数准备完毕，发送RPC请求到所有的follower,follower再接收到这样的请求之后，处理如下：</p>
<ul>
<li>重置HeartbeatTimeout</li>
<li>检查传过来的请求term和当前follower的term
<pre><code>Reply false if term &lt; currentTerm
</code></pre>
</li>
<li>检查prevLogIndex和prevLogTerm和当前follower的对应index的log是否一致，
<pre><code>Reply false if log doesn’t contain an entry at prevLogIndex whose term matches prevLogTerm
</code></pre>
<p>这里可能就是不一致的，因为初始prevLogIndex和prevLogTerm是leader上log的lastLog，不一致的话返回false，同时将该follower上log的lastIndex传送给leader</li>
<li>leader接收到上述false之后，会记录该follower的上述lastIndex
<pre><code>macthIndex=上述lastIndex
nextIndex=上述lastIndex+1
</code></pre>
<p>然后leader会从新按照上述规则，发送新的prevLogIndex、prevLogTerm、和entries数组</li>
<li>follower检查prevLogIndex和prevLogTerm和对应index的log是否一致（目前一致了）</li>
<li>然后follower就开始将entries中的数据全部覆盖到本地对应的index上，如果没有则算是添加如果有则算是更新，也就是说和leader的保持一致</li>
<li>最后follower将最后复制的index发给leader,同时返回ok，leader会像上述一样来更新follower的macthIndex</li>
</ul>
</li>
<li>2.2.3 leader统计过半复制的entries
<p>leader一旦发现有些entries已经被过半的follower复制了，则就将该entry提交，将commitIndex提升至该entry的index。（这里是按照entry的index先后顺序提交的），具体的实现可以通过follower发送过来macthIndex来判定是否过半了</p>
<p>一旦可以提交了，leader就将该entry应用到状态机中，然后给客户端回复OK</p>
<p>然后在下一次heartBeat心跳中，将commitIndex就传给了所有的follower，对应的follower就可以将commitIndex以及之前的entry应用到各自的状态机中了</li>
</ul>
<h1>3 安全</h1>
<h2>3.1 选举约束</h2>
<p>对于上述leader选举有个重点强调的地方就是</p>
<pre><code>被选举出来的leader必须要包含所有已经比提交的entries
</code></pre>
<p>如leader针对复制过半的entry提交了，但是某些follower可能还没有这些entry，当leader挂了，该follower如果被选举成leader的时候，就可能会覆盖掉了上述的entry了，造成不一致的问题，所以新选出来的leader必须要满足上述约束</p>
<p>目前对于上述约束的简单实现就是：</p>
<pre><code>只要当前server的log比半数server的log都新就可以，这里的新就是上述说的：

谁的lastLog的term越大谁越新，如果term相同，谁的lastLog的index越大谁越新
</code></pre>
<p>但是正是这个实现并不能完全实现约束，才会产生下面的另外一个问题，一会会详细案例来说明这个问题</p>
<h2>3.2 当前term的leader是否能够直接提交之前term的entries</h2>
<p>raft给出的答案是：</p>
<pre><code>当前term的leader不能“直接”提交之前term的entries
</code></pre>
<p>也就是可以间接的方式来提交。我们来看下raft给出不能直接提交的案例</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3N0YXRpYy5vc2NoaW5hLm5ldC91cGxvYWRzL2ltZy8yMDE2MTAvMjExNjQ3MjNfdjJSaC5wbmc=.jpg"></p>
<p>最上面一排数字表示的是index，s1-s5表示的是server服务器，a-e表示的是不同的场景，方框里面的数字表示的是term</p>
<p>详细解释如下：</p>
<ul>
<li>a场景：s1是leader,此时处于term2，并且将index为2的entry复制到s2上</li>
<li>b场景：s1挂了，s5当选为leader，处于term3,s5在index为2的位置上接收到了新的entry</li>
<li>c场景：s5挂了，s1当选为leader，处于term4，s1将index为2,term为2的entry复制到了s3上，此时已经满足过半数了
<p>重点就在这里：此时处于term4,但是之前处于term2的entry达到过半数了，s1是提交该entry呢还是不提交呢？</p>
<p>假如s1提交的话，则index为2，term为2的entry就被应用到状态机中了，是不可改变了，此时s1如果挂了，来到term5，s5是可以被选为leader的，因为按照之前的log比对策略来说，s5的最后一个log的term是3比s2 s3 s4的最后一个log的term都大。一旦s5被选举为leader，即d场景，s5会复制index为2,term为3的entry到上述机器上，这时候就会造成之前s1已经提交的index为2的位置被重新覆盖，因此违背了一致性。</p>
<p>假如s1不提交，而是等到term4中有过半的entry了，然后再将之前的term的entry一起提交（这就是所谓的间接提交，即使满足过半，但是必须要等到当前term中有过半的entry才能跟着一起提交），即处于e场景，s1此时挂的话，s5就不能被选为leader了，因为s2 s3的最后一个log的term为4比s5的3大，所以s5获取不到投票，进而s5就不可能去覆盖上述的提交</li>
</ul>
<p>这里再对日志覆盖问题进行详细阐述</p>
<p>日志覆盖包含2种情况：</p>
<ul>
<li>commitIndex之后的log覆盖:是允许的，如leader发送AppendEntries RPC请求给follower，follower都会进行覆盖纠正，以保持和leader一致。</li>
<li>commitIndex及其之前的log覆盖：是禁止的，因为这些已经被应用到状态机中了，一旦再覆盖就出现了不一致性。而上述案例中的覆盖就是指这种情况的覆盖。</li>
</ul>
<p>从这个案例中我们得到的一个新约束就是：</p>
<pre><code>当前term的leader不能“直接”提交之前term的entries
必须要等到当前term有entry过半了，才顺便一起将之前term的entries进行提交
</code></pre>
<p>所以raft靠着这2个约束来进一步保证一致性问题。</p>
<p>再来仔细分析这个案例，其问题就是出在：上述leader选举上，s1如果在c场景下将index为2、term为2的entry提交了，此时s5也就不包含所有的commitLog了，但是s5按照log最新的比较方法还是能当选leader，那就是说log最新的比较方法并不能保证3.1中的选举约束即</p>
<pre><code>被选举出来的leader必须要包含所有已经比提交的entries
</code></pre>
<p>所以可以理解为：正是由于上述选举约束实现上的缺陷才导致又加了这么一个不能直接提交之前term的entries的约束。</p>
<h2>3.3 安全性论证</h2>
<p>Leader Completeness： 如果一个entry被提交了，那么在之后的leader中，必然存在该entry。</p>
<p>经过上述2个约束，就能得出Leader Completeness结论。</p>
<p>正是由于上述“不能直接提交之前term的entries”的约束，所以<strong>任何一个entry的提交必然存在当前term下的entry的提交</strong>。那么此时所有的server中有过半的server都含有当前term(也是当前最大的term)的entry，假设serverA将来会成为leader，此时serverA的lastlog的term必然是不大于当前term的，它要想成为leader，即和其他server pk 谁的log最新，必然是需要满足log的index比他们大的，所以必然含有已提交的entry。</p>
<h1>4 其他注意点</h1>
<h2>4.1 client端</h2>
<p>在client看来：</p>
<p>如果client发送一个请求，leader返回ok响应，那么client认为这次请求成功执行了，那么这个请求就需要被真实的落地，不能丢。</p>
<p>如果leader没有返回ok，那么client可以认为这次请求没有成功执行，之后可以通过重试方式来继续请求。</p>
<p>所以对leader来说：</p>
<p>一旦你给客户端回复OK的话，然后挂了，那么这个请求对应的entry必须要保证被应用到状态机，即需要别的leader来继续完成这个应用到状态机。</p>
<p>一旦leader在给客户端答复之前挂了，那么这个请求对应的entry就不能被应用到状态机了，如果被应用到状态机就造成客户端认为执行失败，但是服务器端缺持久化了这个请求结果，这就有点不一致了。</p>
<p>这个原则同消息队列也是一致的。再来说说什么叫消息队列的消息丢失（很多人还没真正搞明白这个问题）：client向服务器端发送消息，服务器端回复OK了，之后因为服务器端自己的内部机制的原因导致该消息丢失了，这种情况才叫消息队列的消息丢失。如果服务器端没有给你回复OK，那么这种情况就不属于消息队列丢失消息的范畴。</p>
<p>再来看看raft是否能满足这个原则：</p>
<p>leader在某个entry被过半复制了，认为可以提交了，就应用到状态机了，然后向客户端回复OK，之后leader挂了，是可以保证该entry在之后的leader中是存在的</p>
<p>leader在某个entry被过半复制了，然后就挂了，即没有向客户端回复OK，raft的机制下，后来的leader是可能会包含该entry并提交的，或可能直接就覆盖掉了该entry。如果是前者，则该entry是被应用到了状态机中，那么此时就出现一个问题：client没有收到OK回复，但是服务器端竟然可以成功保存了</p>
<p>为了掩盖这种情况，就需要在客户端做一次手脚，即客户端对那么没有回复OK的都要进行重试，客户端的请求都带着一个唯一的请求id，重试的时候也是拿着之前的请求id去重试的</p>
<p>服务器端发现该请求id已经存在提交log中了，那么直接回复OK，如果不在的话，那么再执行一次该请求。</p>
<h2>4.2 follower挂了</h2>
<p>follower挂了，只要leader还满足过半条件就，一切正常。他们挂了又恢复之后，leader是会不断进行重试的，该follower仍然是能恢复正常的</p>
<p>follower在接收AppendEntries RPC的时候是幂等操作</p>
<h2>4.3 集群成员调整</h2>
<p>目前这一块，貌似raft paper的那个实现也被废弃了，各个实现也都是各自的解决办法，如参考下copycat的实现<a href="http://atomix.io/copycat/docs/membership/" rel="external nofollow noreferrer">Membership Changes</a></p>
<p>最后就再说下raft的java版实现，可以看下<a href="https://github.com/atomix/copycat" rel="external nofollow noreferrer">copycat</a></p>
<h1>5 后续计划</h1>
<p>后续会再详细分析下ZooKeeper中的ZAB协议实现，然后对比下raft，有哪些设计上的不同点。</p>
<p>欢迎关注微信公众号：乒乓狂魔</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3N0YXRpYy5vc2NoaW5hLm5ldC91cGxvYWRzL2ltZy8yMDE2MTAvMjcxOTA4NTZfWTBwTS5qcGc=.jpg"></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:42:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%b8%80%e8%87%b4%e6%80%a7/" title="一致性">一致性</a>, <a href="https://www.iamivan.net/tag/raft/" title="raft">raft</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Raft算法赏析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Z1KZb.html" rel="bookmark">分布式一致性算法：Raft 算法（论文翻译）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				点击我的博客查看原文. Raft 算法是可以用来替代 Paxos 算法的分布式一致性算法,而且 raft 算法比 Paxos 算法更易懂且更容易实现.本文对 raft 论文进行翻译,希望能有助于读者更方便地理解 raft 的思想.如果对 Paxos 算法感兴趣,可以看我的另一篇文章:分布式系列文章--Paxos算法原理与推导 摘要 Raft 是用来管理复制日志(replicated log)的一致性协议.它跟 multi-Paxos 作用相同,效率也相当,但是它的组织结构跟 Paxos 不同.这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9YgQRM.html" rel="bookmark">ZooKeeper的一致性算法赏析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 ZAB介绍 ZAB协议全称就是ZooKeeper Atomic Broadcast protocol,是ZooKeeper用来实现一致性的算法,分成如下4个阶段. 先来解释下部分名词 electionEpoch:每执行一次leader选举,electionEpoch就会自增,用来标记leader选举的轮次 peerEpoch:每次leader选举完成之后,都会选举出一个新的peerEpoch,用来标记事务请求所属的轮次 zxid:事务请求的唯一标记,由leader服务器负责进行分配.由2部分			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6N6yJM.html" rel="bookmark">Raft对比ZAB协议</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				系列文章 Raft算法赏析 ZooKeeper的一致性算法赏析 Raft对比ZAB协议 0 一致性问题 本篇文章想总结下Raft和ZAB在处理一些一致性问题上的做法,详见之前对这2个算法的描述 Raft算法赏析 ZooKeeper的一致性算法赏析 上述分别是针对如下算法实现的讨论: Raft的实现copycat,由于Raft算法本身已经介绍的相当清晰,copycat基本上和Raft算法保持一致 ZAB的实现ZooKeeper,由于ZooKeeper里面的很多实现细节并没有在ZAB里体现(ZAB里			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrW9y6p.html" rel="bookmark">【区块链之技术进阶】掰一掰区块链共识机制与分布式一致性算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				咱们在之前的很多篇文章里简单地提起了&quot;共识算法&quot;以及&quot;共识攻击&quot;,大家应该对于我们之前提到的&quot;共识攻击&quot;印象还比较深刻吧,对的,就是我们所说的这和公司占有股份一个道理,当你占有整个公司&quot;51%&quot;的股份时,那就是控股了,岂不是可以为所欲为了呢?在区块链技术这也一样,咱们都知道区块链记账以后是不可以篡改的,就算是合理交易写错地址了也不行!but!当你能说服整个区块链上51%的结点同意你的请求时就能够修改记账信息,当这一方法用到不好			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5R3kaz.html" rel="bookmark">如何基于Raft绕过&ZeroWidthSpace;分布式算法一致性的那些痛？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文根据DCOS联盟第6期线上分享整理而成.   讲师介绍  姚云 数人云研发工程师     目前负责Go语言分布式系统的相关研发,Linux社区成员,擅长Python,熟悉C#开发.   主题大纲: 1.点拨分布式系统和Raft算法要点 2.深入剖析Raft实现原理 3.干货:基于Raft的分布式系统实战经验   最近我们开源了一个运行在Mesos上的分布式调度器swan(https://github.com/Dataman-Cloud/swan),在研发过程中发现由于目前的分布式存储并不能满			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0boWvbv.html" rel="bookmark">113期：电子书《阿里巴巴技术实战2016年刊》重磅发布，免费下载！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本期头条   • [资料合集]首届阿里开源峰会回顾:讲义PDF+活动视频! • [在线峰会]即将直播:大数据技术峰会 • 微博红包技术最佳实践:架构及运维 • 阿里开源数据库AliSQL最佳实践   技术干货   如何使用好阿里云的网络安全隔离?深入分享阿里云ECS安全组实践经验 阿里云的ECS有经典网络和专有网络(VPC)两种网络类型.新业务建议优先考虑VPC网络,阿里云也将于年中开放经典网络的存量服务器向VPC网络迁移的功能.对于大家关注的云服务器的网络安全实践内容,我们特别邀请专家进行了深			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMyWQZz.html" rel="bookmark">Redis集群的一点一滴</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文并非介绍如何搭建一个集群,也不是介绍集群如何使用,重点是分享一些大家在使用集群过程中经常遇到的,经常提出来的问题: 问题一 Exception: Could not get resource from pool    使用jedis客户端,无论缓存是以集群模式还是单点模式部署,凡是遇到这种问题,归结于无法从连接池中获取到连接,那么哪些原因导致获取链接失败呢?    1.1 跨机房访问,注意网络是否可以访问,有无防火墙:    1.2 本机访问,若redis以单机模式部署,注意是否启用密码认证			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP8Q8vp.html" rel="bookmark">大数据生态圈&amp;amp&semi;Docker发展概况：最新动态及国内情况</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录: [大数据生态圈] Hadoop Hadoop 3.0.0 Alpha版本发布 Druid Druid 0.9.2版本发布 Kudu Apache Kudu 1.1.0正式发布 HAWQ HAWQ 2.1.0.0企业版正式发布 [Docker发展概况] 官方版本发布情况 国内情况 落地情况 感谢名单   大数据生态圈 一.Hadoop   Hadoop 3.0.0 Alpha版本发布   由于Hadoop 2.0是基于JDK 1.7开发的,而JDK 1.7在2015年4月已停止更新,所以H			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze75mVM.html" rel="bookmark">Docker网络和服务发现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是Docker网络和服务发现[编者的话] 本文是&lt;Docker网络和服务发现&gt;一书的全文,作者是Michael Hausenblas.本文介绍了Docker世界中的网络和服务发现的工作原理,并提供了一系列解决方案. 前言 当你开始使用Docker构建应用的时候,对于Docker的能力和它带来的机会,你会感到很兴奋.它可以同时在开发环境和生产环境中运行,只需要将一切打包进一个Docker镜像中,然后通过Docker Hub分发镜像,这是很直接了当的.你会发现以下过程很令人满意:你可以快速			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmDlMe.html" rel="bookmark" class="title">如何关闭win7系统错误提示报告？</a>
					<div>
						  1.其实,在我们的win7旗舰版系统中,我们要实现错误提示报告窗口的屏蔽,可以在注册表中实现.首先,我们同时按下win7旗舰版电脑键盘上的win+R快捷键打开电脑的运行窗口,在打开的运行窗口中,我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMy35dz.html" rel="bookmark" class="title">整合Activiti Modeler到业务系统（或BPM平台）</a>
					<div>
						1. 为什么要整合 Activiti 5.10版本把原本独立的Activiti Modeler模块整合到了Activiti Explorer中,两者相结合使用起来很方便,通过Modeler设计的流程模 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpdmymz.html" rel="bookmark" class="title">FACEBOOK产品总监：聊聊资深设计师经历过的瓶颈期</a>
					<div>
						  打磨一个成熟的产品和设计一个全新的项目,你选哪个?今天Facebook总监的这篇好文说出了不少设计师的心声,为一个存在了5年以上的复杂产品做改进优化,难度非常非常大,特别当你要考虑到留存率.转化率 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMRKOep.html" rel="bookmark" class="title">Google Adsense帐号被封这件事</a>
					<div>
						Google Adsense广告发布者最不情愿遇到的情况就是帐号被停止,如果你的Google Adsense帐号被封?或者你怕Google Adsense帐号被封?看看下面的文字能不能对您有所帮助.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvDO5z.html" rel="bookmark" class="title">地方论坛社区建设的思考</a>
					<div>
						社区  近年来,站长们对网站建设要落地生根,大概已经成为了共识.我也一直对做地方网站非常感兴趣.于06年5月下载了一个DISCUZ程序,开通了地方论坛.(无锡论坛http://www.wuxiw.co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMl9EOp.html" rel="bookmark" class="title">开发能够互操作的Web Services - 整合Java and Microsoft &period;NET</a>
					<div>
						services|web Developing Interoperable Web Services - Integrating Java and Microsoft .NETInteroperabi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOye8M.html" rel="bookmark" class="title">浅谈如何处理好网站与蜘蛛的关系</a>
					<div>
						相信有很多人都有研究过蜘蛛,因为我们网站的内容都是需要靠蜘蛛来爬取,提供给搜索引擎,要是蜘蛛来爬取完网站回去时对我们网站充满怨气的话,那相信搜索引擎对网站也不会有什么好感,所以一般我们做网站时都会研究 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkXDdz.html" rel="bookmark" class="title">巧用不同类型关键词设计站点结构</a>
					<div>
						对于我们的站点结构,我们以权重的流动来看,我们可以它比作是一颗大树.我们站点的主导航栏就是我们的根茎,而面包屑.分类就是树干,至于我们的内容页面就是这颗树的枝叶.那么我们如何让我们的站点权重可以通过合 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7AN4b.html" rel="bookmark" class="title">IOConsole updater has encounter a problem问题</a>
					<div>
						你是否也遇到过 &quot;IOConsole updater&quot; has encounter a problem 问题? Windows-&gt;Preferences-&gt;Run/De ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4jBVp.html" rel="bookmark" class="title">IsLine FrameWork系列之二&mdash;&mdash;命名空间与契约</a>
					<div>
						接上文 ILFW框架以最底层为基础,层层堆叠,上层一依赖于下层提供的服务,并实现其派发的接口,形成完整的FrameWork,不过由于时间原因,有些 Provider之间的聚合偏高,例如AppLogPr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKmAOp.html" rel="bookmark" class="title">Eclipse和WebSphere Studio新的项目交换功能</a>
					<div>
						引言 一位&quot;牛气&quot;的程序员独自一人就能够编写代码的年代已经过去了.事实上,在每个重要的开发项目中共享代码都是有必要的.Eclipse和IBM WebSphere Studio提供了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2Wq5M.html" rel="bookmark" class="title">图片加载进度实时显示</a>
					<div>
						 &lt;html&gt;   &lt;head&gt; &lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;text/html; c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZ1wwz.html" rel="bookmark" class="title">Word2003背景颜色及文字后背景颜色去掉方法</a>
					<div>
						  有很多新手朋友们问Word2003背景颜色如何去掉,由于情况有很多,下面举几个常见的情况:整个word背景有颜色而不是某些字有颜色.文字被添加了背景色.文字被加了字符底纹.从网页上复制下来的文字, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7mr3b.html" rel="bookmark" class="title">使用老毛桃u盘启动盘制作工具安装Win7图文教程</a>
					<div>
						此方法节省了转换U盘为USB-hdd之类的时间,操作简便,经过测试之后发现很实用. 此方法需要准备的东西: 1.win7系统iso文件 2.老毛桃U盘启动盘制作工具 3.一个至少4G的U盘 4.一台可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42ZO8M.html" rel="bookmark" class="title">iOS之UI--使用SWRevealViewController实现侧边菜单功能详解实例</a>
					<div>
						使用SWRevealViewController实现侧边菜单功能详解 下面通过两种方法详解SWRevealViewController实现侧边菜单功能: 1.使用StoryBoard实现 2.纯代码实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9E6kgM.html" rel="bookmark" class="title">java数据权限设计-各位大神，求数据权限设计思路</a>
					<div>
						问题描述 各位大神,求数据权限设计思路 求J2ee数据权限的设计思路,基本要求: 部门经理可以查看该部门下的所有数据对象(比如销售订单),销售人员只可以查看自己的销售订单或者查看其他人的销售订单(通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamRGXb.html" rel="bookmark" class="title">关于CocosStudio编辑UI的问题</a>
					<div>
						问题描述 关于CocosStudio编辑UI的问题 本人新手一枚 用Cocosstudio做一个UI的时候发现里面的输入框没法设置背景(因为我看到右边出来的属性中没有背景这么一说) 而且导出的时候有哥 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7Kamp.html" rel="bookmark" class="title">手机&OpenCurlyDoubleQuote;植毒&rdquo;肆意传播 恶意程序被&OpenCurlyDoubleQuote;贱卖&rdquo;低至5元</a>
					<div>
						5元钱能买到什么?一根可爱多.一瓶饮料.一顿早餐?也可能是一个恶意程序!此前,360手机卫士发布的&lt;2016年安卓恶意软件专题报告&gt;显示,恶意软件正以每天70万人次的感染量侵袭手机用户.然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKQqoz.html" rel="bookmark" class="title">linux shell-Linux Bash脚本理解的问题</a>
					<div>
						问题描述 Linux Bash脚本理解的问题 我看到一段bash脚本,请问怎么理解?这个hide 和下面的 ${hide} echo hide := @ SHOWTIMECMD := date &qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXyLrb.html" rel="bookmark" class="title">北京荣科事达信息技术有限公司招聘C&num;程序员</a>
					<div>
						问题描述 北京荣科事达信息技术有限公司招聘C#程序员.我公司一直耕耘于医药行业信息化领域,日前与国家药监局开展了EDC/eCRF(临床试验数据采集)系统的试点研发工作,该领域在美国已经发展了14年,目 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWkvqM.html" rel="bookmark" class="title">贵州大数据产业异军突起</a>
					<div>
						连日多雨,汛期已至,可忙坏了贵州省东方世纪科技股份有限公司董事长李胜,&quot;我们要派人到省防汛办,还要在公司用'东方祥云'系统进行洪涝灾害预测,一有灾情立马通报.&quot; 传统洪涝灾害预测依 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgNAkM.html" rel="bookmark" class="title">《Cisco安全防火墙服务模块（FWSM）解决方案》&mdash;&mdash;1&period;5 IP地址重用</a>
					<div>
						1.5 IP地址重用 Cisco安全防火墙服务模块(FWSM)解决方案 所有防火墙都有一个共同的特性,那就是网络地址转换(NAT)和端口地址转换(PAT).NAT隐藏了内部使用的IP地址规划,而PAT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDnr7KM.html" rel="bookmark" class="title">谷歌微软提供数万用户资料</a>
					<div>
						据新华社电美国一些大型网络公司3日向政府律师和公众披露了更多新数据.这些数据显示,过去几年,美国国家安全局常以反恐调查和情报相关调查为由,向这些互联网热门网站索要用户信息,包括等. 数据显示,谷歌和微 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWVAKz.html" rel="bookmark" class="title">40款非常有用的 jQuery 插件推荐（系列一）&lowbar;jquery</a>
					<div>
						今天开始将发布系列文章向大家分享40款非常有用的 jQuery 插件. MotionCAPTCHA ( 演示 | 下载 )  MotionCAPTCHA 是一款非常特别的 jQuery 验证码插件,要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYA9Zb.html" rel="bookmark" class="title">3款免费php mysql&sol;无限广告&sol;100G&sol;可绑米免费PHP空间</a>
					<div>
						可绑米100M免费PHP空间 100MB : 月流量限制为:无限流量 : 支持PHP5,并免费提供3个MySQL数据库 : 该免费空间没有强制广告 : 申请地址:http://en.olympe-ne ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW79AqM.html" rel="bookmark" class="title">图片-android studio问题   Protocol family unavailable</a>
					<div>
						问题描述 android studio问题 Protocol family unavailable 遇到一个很奇怪的问题,一开始,我去了学校老师的办公室,打开androidstudio就是下面这样 试 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7wY1dz.html" rel="bookmark" class="title">从Chrome App看微信小程序的发展前景&lowbar;其它综合</a>
					<div>
						 关于微信小程序的消息算是这几天互联网新闻中的一个热点话题,各种推想猜测也是层出不穷.小程序只是处于一个内测阶段,但是,2010年谷歌公司也曾经开发过基于Chrome浏览器的Chrome App,两者 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7w1vKz.html" rel="bookmark" class="title">击败区块链、智能理财企业，菲律宾版&OpenCurlyDoubleQuote;蚂蚁金服&rdquo;摘得金融科技节桂冠 &vert; Fintech Final 2017</a>
					<div>
						1月19日是2017年香港&quot;金融科技节&quot;--&quot;Fintech Finals 2017(FF17)&quot;的最后一天,上午在完成最后的演讲与论坛后,下午便进入由23家来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJeg14p.html" rel="bookmark" class="title">张菲恋情&OpenCurlyDoubleQuote;吹水&rdquo;多与旧爱林慧萍难以复合&lpar;图&rpar;</a>
					<div>
						王治平和王若琳被誉为&quot;乐坛最强父女档&quot;. 张菲大儿子2007年结婚时表示,希望老爸能找个伴. 林慧萍是台湾资深玉女歌手. 有传林慧萍离婚,全因丈夫潘博照的助手徐怀瑛(歌手徐怀钰的堂 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7weB4z.html" rel="bookmark" class="title">easyui的datagrid问题</a>
					<div>
						问题描述 easyui的datagrid问题 如图所示,我想点击修改的时候能获取这一行的数据,不知道该怎么弄,求解答. 我现在是这样写的,点击的时候会调用一个js函数,函数里会获取所有选中的行,但是现 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
